Attribute VB_Name = "DIModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Dim DI As DirectInput
Dim DIDEV As DirectInputDevice
Dim DIMouse As DirectInputDevice
Dim MouseState As DIMOUSESTATE

Public Sub InitDInput(ByVal WindowHandle As Long)
    Set DI = DX7.DirectInputCreate()
    Set DIDEV = DI.CreateDevice("GUID_SysKeyboard")
    DIDEV.SetCommonDataFormat DIFORMAT_KEYBOARD
    DIDEV.SetCooperativeLevel WindowHandle, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    DIDEV.Acquire
    Set DIMouse = DI.CreateDevice("GUID_SysMouse")
    DIMouse.SetCommonDataFormat DIFORMAT_MOUSE
    DIMouse.SetCooperativeLevel WindowHandle, DISCL_FOREGROUND Or DISCL_EXCLUSIVE
    DIMouse.Acquire
End Sub

Public Sub CheckInput()
    Dim KeyboardState(0 To 255) As Byte
    On Error GoTo ErrEnd
    DIDEV.Acquire
    DIDEV.GetDeviceState 256, KeyboardState(0)
    If (KeyboardState(DIK_A) And &H80&) <> 0 Then
        PLAYER.Move = PLAYER.Move Or MOVE_LEFT
    End If
    If (KeyboardState(DIK_D) And &H80&) <> 0 Then
        PLAYER.Move = PLAYER.Move Or MOVE_RIGHT
    End If
    If (KeyboardState(DIK_W) And &H80&) <> 0 Then
        PLAYER.Move = PLAYER.Move Or MOVE_FORE
    End If
    If (KeyboardState(DIK_S) And &H80&) <> 0 Then
        PLAYER.Move = PLAYER.Move Or MOVE_BACK
    End If
    'Fog-Eigenschaften
    If (KeyboardState(DIK_ADD) And &H80&) <> 0 Then
        myFOG.FogDensity = myFOG.FogDensity + 0.001
        If myFOG.FogDensity > 0.1 Then myFOG.FogDensity = 0.1
    End If
    If (KeyboardState(DIK_SUBTRACT) And &H80&) <> 0 Then
        myFOG.FogDensity = myFOG.FogDensity - 0.001
        If myFOG.FogDensity < 0.0001 Then myFOG.FogDensity = 0.0001
    End If
    If (KeyboardState(DIK_1) And &H80&) <> 0 Then
        myFOG.FogStart = myFOG.FogStart + 0.001
    End If
    If (KeyboardState(DIK_2) And &H80&) <> 0 Then
        myFOG.FogStart = myFOG.FogStart - 0.001
    End If
    If (KeyboardState(DIK_3) And &H80&) <> 0 Then
        myFOG.FogEnd = myFOG.FogEnd + 0.001
    End If
    If (KeyboardState(DIK_4) And &H80&) <> 0 Then
        myFOG.FogEnd = myFOG.FogEnd - 0.001
    End If
    Exit Sub
ErrEnd:
    Running = False
End Sub

Public Sub CheckMouse()
    On Error GoTo ErrEnd
    DIMouse.GetDeviceStateMouse MouseState
    With PLAYER
        .TurnHor = MouseState.x
        .TurnVer = MouseState.y
    End With
    Exit Sub
ErrEnd:
    Running = False
End Sub

Public Sub TerminateDInput()
    On Error GoTo ErrEnd
    DIDEV.Unacquire
    Set DIDEV = Nothing
    DIMouse.Unacquire
    Set DIMouse = Nothing
    Set DI = Nothing
    Exit Sub
ErrEnd:
    Running = False
End Sub





