Attribute VB_Name = "MathModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++ Modul fr mathematische Funktionen div. Art       +++
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public PI As Single

Dim Opposite As Single
Dim Adjacent As Single
Dim Hypotenuse As Single

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'Sollte vom Sub_Main aus immer aufgerufen werden
Public Sub SetPI()
    PI = Atn(1) * 4
End Sub

Function DegToRad(Degrees As Double) As Double
    DegToRad = Degrees / 180 * PI
End Function

Function RadToDeg(Radians As Double) As Double
    RadToDeg = Radians * 180 / PI
End Function

Function GetDistance(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
    On Error GoTo ErrEnd
    Opposite = Abs(X2 - X1)
    Adjacent = Abs(Y1 - Y2)
    Hypotenuse = Sqr(Opposite * Opposite + Adjacent * Adjacent)
    GetDistance = Hypotenuse
    Exit Function
ErrEnd:
    GetDistance = 0
End Function

Function GetAngle(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Double
    On Error GoTo ErrEnd
    If Y2 = Y1 Then
        If (X2 - X1) < 0 Then GetAngle = 3 * PI / 2
        If (X2 - X1) > 0 Then GetAngle = PI / 2
    Else
        If (Y2 - Y1) > 0 Then GetAngle = Atn((X2 - X1) / (Y2 - Y1))
        If (Y2 - Y1) < 0 Then GetAngle = Atn((X2 - X1) / (Y2 - Y1)) + PI
    End If
    GetAngle = 180 - RadToDeg(GetAngle)
    If GetAngle < 0 Then GetAngle = GetAngle + 360
    Exit Function
ErrEnd:
    GetAngle = 0
End Function
